# class Point

#### package openfl.geom

Available on all platforms

The Point object represents a location in a two-dimensional coordinate system, where x represents the horizontal axis and y represents the vertical axis.

The following code creates a point at(0,0):

Methods and properties of the following classes use Point objects:

- BitmapData
- DisplayObject
- DisplayObjectContainer
- DisplacementMapFilter
- NativeWindow
- Matrix
- Rectangle

You can use the `new Point()` constructor to create a Point object.

### Constructor

###

`new (x:Float = 0, y:Float = 0)`

Creates a new point. If you pass no parameters to this method, a point is created at(0,0).

Parameters:

`x` | The horizontal coordinate.
`y` | The vertical coordinate.

### Variables

###

`read onlywrite onlylength:Float`

The length of the line segment from(0,0) to this point.

###

`x:Float`

The horizontal coordinate of the point. The default value is 0.

###

`y:Float`

The vertical coordinate of the point. The default value is 0.

### Methods

###

`add (v:Point):Point`

Adds the coordinates of another point to the coordinates of this point to create a new point.

Parameters:

`v` | The point to be added.

Returns:

The new point.

###

`clone ():Point`

Creates a copy of this Point object.

Returns:

The new Point object.

###

`copyFrom (sourcePoint:Point):Void`

###

`equals (toCompare:Point):Bool`

Determines whether two points are equal. Two points are equal if they have the same x and y values.

Parameters:

`toCompare` | The point to be compared.

Returns:

A value of `true` if the object is equal to this Point object; `false` if it is not equal.

###

`normalize (thickness:Float):Void`

Scales the line segment between(0,0) and the current point to a set length.

Parameters:

`thickness` | The scaling value. For example, if the current point is (0,5), and you normalize it to 1, the point returned is at(0,1).

Returns:

The normalized point.

###

`offset (dx:Float, dy:Float):Void`

Offsets the Point object by the specified amount. The value of `dx` is added to the original value of x to create the new x value. The value of `dy` is added to the original value of y to create the new y value.

Parameters:

`dx` | The amount by which to offset the horizontal coordinate, x.
`dy` | The amount by which to offset the vertical coordinate, y.

###

`setTo (xa:Float, ya:Float):Void`

###

`subtract (v:Point):Point`

Subtracts the coordinates of another point from the coordinates of this point to create a new point.

Parameters:

`v` | The point to be subtracted.

Returns:

The new point.

###

`toString ():String`

Returns a string that contains the values of the x and y coordinates. The string has the form `"(x=_x_, y=_y_)"`, so calling the `toString()` method for a point at 23,17 would return `"(x=23, y=17)"`.

Returns:

The string representation of the coordinates.

### Static methods

###

`staticdistance (pt1:Point, pt2:Point):Float`

Returns the distance between `pt1` and `pt2`.

Parameters:

`pt1` | The first point.
`pt2` | The second point.

Returns:

The distance between the first and second points.

###

`staticinterpolate (pt1:Point, pt2:Point, f:Float):Point`

Determines a point between two specified points. The parameter `f` determines where the new interpolated point is located relative to the two end points specified by parameters `pt1` and `pt2`. The closer the value of the parameter `f` is to `1.0`, the closer the interpolated point is to the first point(parameter `pt1`). The closer the value of the parameter `f` is to 0, the closer the interpolated point is to the second point(parameter `pt2`).

Parameters:

`pt1` | The first point.
`pt2` | The second point.
`f` | The level of interpolation between the two points. Indicates where the new point will be, along the line between `pt1` and `pt2`. If `f`=1, `pt1` is returned; if `f`=0, `pt2` is returned.

Returns:

The new, interpolated point.

###

`staticpolar (len:Float, angle:Float):Point`

Converts a pair of polar coordinates to a Cartesian point coordinate.

Parameters:

`len` | The length coordinate of the polar pair.
`angle` | The angle, in radians, of the polar pair.

Returns:

The Cartesian point.